----------------------------------------------------------------------------------
-- Company: UAM 
-- Design Name: bin_reader_pkg (package)
-- Project Name: bin_reader
-- Description: 
--   Provides auxiliary functions, etc. for bin_reader project.
-- Dependencies: 
--   (none)
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

package bin_reader_pkg is

  -- Get the logarithm in base 2 of the given integer, rounded up to the next
  --  integer (log2_ceil(8) = log2_ceil(7) = 3):
  function log2_ceil (constant i_number : in integer  ) return integer;

end bin_reader_pkg;


package body bin_reader_pkg is

  function log2_ceil (constant i_number : in integer  ) return integer is
    variable l_aux : integer;
  begin
    l_aux := 0;
    while i_number > 2**l_aux loop
      l_aux := l_aux + 1;
    end loop;
    return l_aux; 
  end log2_ceil;
 
end bin_reader_pkg;
