----------------------------------------------------------------------------------
-- Company: UAM 
-- Design Name: spram
-- Description: 
--   Generic Single-Port RAM memory, in Xilinx FPGAs infers read-first block
--   RAM.
-- Dependencies: 
--   (none)
----------------------------------------------------------------------------------
library ieee;   
use ieee.std_logic_1164.all;   
use ieee.std_logic_unsigned.all; 
 
-------------------------------------------------------------------------------
-- Entity

entity spram is 
  generic (
           SIZE : integer := 1024;
           ADDR_WIDTH : integer := 10;
           DATA_WIDTH : integer := 8
          );
  port (Clk      : in  std_logic;   
        We       : in  std_logic;   
        Address  : in  std_logic_vector(ADDR_WIDTH-1 downto 0);   
        DataIn   : in  std_logic_vector(DATA_WIDTH-1 downto 0);   
        DataOut  : out std_logic_vector(DATA_WIDTH-1 downto 0)
       );   
end spram;   

-------------------------------------------------------------------------------
-- Architecture

architecture read_first of spram is   
  type ram_type is array (0 to SIZE-1) of std_logic_vector (DATA_WIDTH-1 downto 0);   
  signal RAM : ram_type;  
begin   
  process (Clk)   
  begin   


  end process;   
end read_first; 
