----------------------------------------------------------------------------------
-- Company: UAM 
-- Design Name: bin_reader_tb
-- Project Name: bin_reader
-- Description: 
--   Simple, non-automatic testbench for bin_reader.
-- Dependencies: 
--   bin_reader
----------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.ALL;
 
ENTITY bin_reader_tb IS
END bin_reader_tb;
 
ARCHITECTURE behavior OF bin_reader_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
   COMPONENT bin_reader
   PORT(
        Clk : IN  std_logic;
        ResetX : IN  std_logic;
        Switches : IN  std_logic_vector(7 downto 0);
        Segments : OUT  std_logic_vector(7 downto 0);
        Anodes : OUT  std_logic_vector(3 downto 0)
       );
   END COMPONENT;
    

   --Inputs
   signal Clk : std_logic := '0';
   signal ResetX : std_logic := '0';
   signal Switches : std_logic_vector(7 downto 0) := (others => '0');

    --Outputs
   signal Segments : std_logic_vector(7 downto 0);
   signal Anodes : std_logic_vector(3 downto 0);

   -- Clock period definitions
   constant Clk_period : time := 10 ns;
 
BEGIN
 
   -- Instantiate the Unit Under Test (UUT)
   uut: bin_reader PORT MAP (
          Clk => Clk,
          ResetX => ResetX,
          Switches => Switches,
          Segments => Segments,
          Anodes => Anodes
        );

   -- Clock process definitions
   Clk_process :process
   begin
      Clk <= '0';
      wait for Clk_period/2;
      Clk <= '1';
      wait for Clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin                
      ResetX <= '1';
      wait for Clk_period*10;
      ResetX <= '0';
      wait for Clk_period*300;
      Switches <= conv_std_logic_vector (125,8);
      wait for Clk_period*10;
 
      wait;
   end process;

END;
